/*
 * Copyright IBM Corp. and others 1991
 *
 * This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License 2.0 which accompanies this
 * distribution and is available at https://www.eclipse.org/legal/epl-2.0/
 * or the Apache License, Version 2.0 which accompanies this distribution
 * and is available at https://www.apache.org/licenses/LICENSE-2.0.
 *
 * This Source Code may also be made available under the following
 * Secondary Licenses when the conditions for such availability set
 * forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
 * General Public License, version 2 with the GNU Classpath
 * Exception [1] and GNU General Public License, version 2 with the
 * OpenJDK Assembly Exception [2].
 *
 * [1] https://www.gnu.org/software/classpath/license.html
 * [2] https://openjdk.org/legal/assembly-exception.html
 *
 * SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
 */
package com.ibm.j9ddr.vm29.structure;

/**
 * Structure: _ARM64_FPCR_REG
 *
 * This stub class represents a class that can return in memory offsets
 * to VM C and C++ structures.
 *
 * This particular implementation exists only to allow StructurePointer code to
 * compile at development time.  This is never loaded at run time.
 *
 * At runtime generated byte codes returning actual offset values from the core file
 * will be loaded by the StructureClassLoader.
 */
public final class _ARM64_FPCR_REG {

	// VM Constants

	public static final long SIZEOF;

	// Offsets

	public static final int _AHP_s_;
	public static final int _AHP_b_;
	public static final int _DN_s_;
	public static final int _DN_b_;
	public static final int _DZE_s_;
	public static final int _DZE_b_;
	public static final int _FZ_s_;
	public static final int _FZ_b_;
	public static final int _FZ16_s_;
	public static final int _FZ16_b_;
	public static final int _IDE_s_;
	public static final int _IDE_b_;
	public static final int _IOE_s_;
	public static final int _IOE_b_;
	public static final int _IXE_s_;
	public static final int _IXE_b_;
	public static final int _Len_s_;
	public static final int _Len_b_;
	public static final int _OFE_s_;
	public static final int _OFE_b_;
	public static final int _RMode_s_;
	public static final int _RMode_b_;
	public static final int _Stride_s_;
	public static final int _Stride_b_;
	public static final int _UFE_s_;
	public static final int _UFE_b_;
	public static final int _ValueOffset_;
	public static final int _res0_1_s_;
	public static final int _res0_1_b_;
	public static final int _res0_2_s_;
	public static final int _res0_2_b_;
	public static final int _res0_3_s_;
	public static final int _res0_3_b_;

	// Static Initializer

	private static final boolean RUNTIME = false;

	static {
		if (!RUNTIME) {
			throw new IllegalArgumentException("This stub class should not be on your classpath");
		}

		SIZEOF = 0;
		_AHP_s_ = 0;
		_AHP_b_ = 0;
		_DN_s_ = 0;
		_DN_b_ = 0;
		_DZE_s_ = 0;
		_DZE_b_ = 0;
		_FZ_s_ = 0;
		_FZ_b_ = 0;
		_FZ16_s_ = 0;
		_FZ16_b_ = 0;
		_IDE_s_ = 0;
		_IDE_b_ = 0;
		_IOE_s_ = 0;
		_IOE_b_ = 0;
		_IXE_s_ = 0;
		_IXE_b_ = 0;
		_Len_s_ = 0;
		_Len_b_ = 0;
		_OFE_s_ = 0;
		_OFE_b_ = 0;
		_RMode_s_ = 0;
		_RMode_b_ = 0;
		_Stride_s_ = 0;
		_Stride_b_ = 0;
		_UFE_s_ = 0;
		_UFE_b_ = 0;
		_ValueOffset_ = 0;
		_res0_1_s_ = 0;
		_res0_1_b_ = 0;
		_res0_2_s_ = 0;
		_res0_2_b_ = 0;
		_res0_3_s_ = 0;
		_res0_3_b_ = 0;
	}

}
