/*
 * Copyright IBM Corp. and others 1991
 *
 * This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License 2.0 which accompanies this
 * distribution and is available at https://www.eclipse.org/legal/epl-2.0/
 * or the Apache License, Version 2.0 which accompanies this distribution
 * and is available at https://www.apache.org/licenses/LICENSE-2.0.
 *
 * This Source Code may also be made available under the following
 * Secondary Licenses when the conditions for such availability set
 * forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
 * General Public License, version 2 with the GNU Classpath
 * Exception [1] and GNU General Public License, version 2 with the
 * OpenJDK Assembly Exception [2].
 *
 * [1] https://www.gnu.org/software/classpath/license.html
 * [2] https://openjdk.org/legal/assembly-exception.html
 *
 * SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
 */
package com.ibm.j9ddr.vm29.structure;

/**
 * Structure: _ARM64_FPSR_REG
 *
 * This stub class represents a class that can return in memory offsets
 * to VM C and C++ structures.
 *
 * This particular implementation exists only to allow StructurePointer code to
 * compile at development time.  This is never loaded at run time.
 *
 * At runtime generated byte codes returning actual offset values from the core file
 * will be loaded by the StructureClassLoader.
 */
public final class _ARM64_FPSR_REG {

	// VM Constants

	public static final long SIZEOF;

	// Offsets

	public static final int _C_s_;
	public static final int _C_b_;
	public static final int _DZC_s_;
	public static final int _DZC_b_;
	public static final int _IDC_s_;
	public static final int _IDC_b_;
	public static final int _IOC_s_;
	public static final int _IOC_b_;
	public static final int _IXC_s_;
	public static final int _IXC_b_;
	public static final int _N_s_;
	public static final int _N_b_;
	public static final int _OFC_s_;
	public static final int _OFC_b_;
	public static final int _QC_s_;
	public static final int _QC_b_;
	public static final int _UFC_s_;
	public static final int _UFC_b_;
	public static final int _V_s_;
	public static final int _V_b_;
	public static final int _ValueOffset_;
	public static final int _Z_s_;
	public static final int _Z_b_;
	public static final int _res0_1_s_;
	public static final int _res0_1_b_;
	public static final int _res0_2_s_;
	public static final int _res0_2_b_;

	// Static Initializer

	private static final boolean RUNTIME = false;

	static {
		if (!RUNTIME) {
			throw new IllegalArgumentException("This stub class should not be on your classpath");
		}

		SIZEOF = 0;
		_C_s_ = 0;
		_C_b_ = 0;
		_DZC_s_ = 0;
		_DZC_b_ = 0;
		_IDC_s_ = 0;
		_IDC_b_ = 0;
		_IOC_s_ = 0;
		_IOC_b_ = 0;
		_IXC_s_ = 0;
		_IXC_b_ = 0;
		_N_s_ = 0;
		_N_b_ = 0;
		_OFC_s_ = 0;
		_OFC_b_ = 0;
		_QC_s_ = 0;
		_QC_b_ = 0;
		_UFC_s_ = 0;
		_UFC_b_ = 0;
		_V_s_ = 0;
		_V_b_ = 0;
		_ValueOffset_ = 0;
		_Z_s_ = 0;
		_Z_b_ = 0;
		_res0_1_s_ = 0;
		_res0_1_b_ = 0;
		_res0_2_s_ = 0;
		_res0_2_b_ = 0;
	}

}
